module.exports = {
  presets: [
    ['@babel/preset-env', {
      modules: false,
      corejs: 3,
      useBuiltIns: 'entry',
    }],
    '@babel/preset-react',
  ],
  plugins: [
    '@babel/plugin-proposal-export-default-from',
    '@babel/plugin-proposal-export-namespace-from',
    [
      '@babel/plugin-proposal-decorators',
      {
        legacy: true,
      },
    ],
    [
      '@babel/plugin-proposal-class-properties',
      {
        loose: true,
      },
    ],
    'lodash',
    [
      'import',
      {
        libraryName: 'dwt-ui',
        style: true,
      },
      'dwt-ui',
    ],
    [
      'import',
      {
        libraryName: 'dwt-ui/pro',
        style: true,
      },
      'dwt-ui-pro',
    ],
    ['try-import', {
      tryImport: 'DwtTryImport',
      hasModule: 'DwtHasModule',
    }],
  ],
};
