"use strict";

var _path = _interopRequireDefault(require("path"));

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _warning = _interopRequireDefault(require("./utils/warning"));

var _getDwtConfig = _interopRequireDefault(require("./webpackConfig/getDwtConfig"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var isInitialized = false;

function initialize(context) {
  if (isInitialized) {
    (0, _warning["default"])(false, '`context` had been initialized');
    return;
  }

  var tmpDirPath = _path["default"].join(__dirname, '../../../tmp');

  context.tmpDirPath = tmpDirPath;

  _mkdirp["default"].sync(tmpDirPath);

  Object.assign(exports, context);
  isInitialized = true;
}

exports.initContext = function initContext(program, dev) {
  var configFile = _path["default"].join(process.cwd(), program.config || 'dwt.config.js');

  var dwtConfig = (0, _getDwtConfig["default"])(configFile);
  initialize({
    dwtConfig: dwtConfig,
    isDev: dev
  });
};