"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = handleGenerateRoute;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _nunjucks = _interopRequireDefault(require("nunjucks"));

var _context = _interopRequireDefault(require("../context"));

var _escapeWinPath = _interopRequireDefault(require("../utils/escapeWinPath"));

var _getPackageRoute = _interopRequireDefault(require("../utils/getPackageRoute"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var routesTemplate = _fs["default"].readFileSync(_path["default"].join(__dirname, '../nunjucks/routes.nunjucks.js')).toString();

function handleGenerateRoute(configEntryName) {
  var tmpDirPath = _context["default"].tmpDirPath,
      isDev = _context["default"].isDev,
      _context$dwtConfig = _context["default"].dwtConfig,
      routes = _context$dwtConfig.routes,
      homePath = _context$dwtConfig.homePath;
  var configRoutes = routes;

  var routesPath = _path["default"].join(tmpDirPath, "routes.".concat(configEntryName, ".js"));

  _nunjucks["default"].configure(routesPath, {
    autoescape: false
  });

  var homePathStr = "createHome(\"/\", ".concat(homePath ? "function() { return import(\"".concat((0, _escapeWinPath["default"])(_path["default"].join(process.cwd(), homePath || '')), "\"); }") : null, ", ").concat(homePath ? "'".concat(homePath, "'") : homePath, ")");

  _fs["default"].writeFileSync(routesPath, _nunjucks["default"].renderString(routesTemplate, {
    routes: Object.keys(configRoutes).map(function (key) {
      return "createRoute(\"/".concat(key, "\", function() { return import(\"").concat((0, _escapeWinPath["default"])(_path["default"].join(process.cwd(), configRoutes[key])), "\"); }, \"").concat(key, "\")");
    }).join(',\n'),
    home: homePathStr,
    source: isDev ? 'src' : 'lib'
  }));

  return routesPath;
}