"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = generateEntry;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _nunjucks = _interopRequireDefault(require("nunjucks"));

var _context = _interopRequireDefault(require("./context"));

var _handleGenerateRoute = _interopRequireDefault(require("./entry/handleGenerateRoute"));

var _escapeWinPath = _interopRequireDefault(require("./utils/escapeWinPath"));

var _handleCollectRoute = _interopRequireDefault(require("./entry/handleCollectRoute"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function generateEntry(configEntryName) {
  var tmpDirPath = _context["default"].tmpDirPath,
      isDev = _context["default"].isDev,
      master = _context["default"].dwtConfig.master; // 收集路由，单模块启动也得配置路径

  (0, _handleCollectRoute["default"])();
  var masterPath = _typeof(master) === 'object' ? master.masterPath : master;
  var masterPathStr = "getMasters(".concat("function() { return import(\"".concat((0, _escapeWinPath["default"])(_path["default"].join(process.cwd(), masterPath)), "\"); }"), ")"); // 生成路由文件

  var routesPath = (0, _handleGenerateRoute["default"])(configEntryName); // 生成主入口文件

  var entryPath = _path["default"].join(tmpDirPath, "entry.".concat(configEntryName, ".js"));

  var entryTemplate = _fs["default"].readFileSync(_path["default"].join(__dirname, './nunjucks/entry.nunjucks.js')).toString();

  _fs["default"].writeFileSync(entryPath, _nunjucks["default"].renderString(entryTemplate, {
    routesPath: (0, _escapeWinPath["default"])(routesPath),
    source: isDev ? 'src' : 'lib',
    master: masterPathStr
  }));
}