"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = getDwtConfig;

var _fs = _interopRequireDefault(require("fs"));

var _autoprefixer = _interopRequireDefault(require("autoprefixer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var defaultConfig = {
  port: 9090,
  output: './dist',
  htmlTemplate: 'index.template.html',
  devServerConfig: {},
  postcssConfig: {
    plugins: [(0, _autoprefixer["default"])({
      browsers: ['last 2 versions', 'Firefox ESR', '> 1%', 'ie >= 8', 'iOS >= 8', 'Android >= 4']
    })]
  },
  babelConfig: function babelConfig(config, mode, env) {
    return config;
  },
  webpackConfig: function webpackConfig(config, mode, env) {
    return config;
  },
  enterPoints: function enterPoints(mode, env) {
    return {};
  },
  entryName: 'index',
  root: '/',
  routes: null,
  local: true,
  server: '',
  clientid: 'localhost',
  webSocketServer: 'ws://localhost:18080',
  titlename: '点我通',
  favicon: 'favicon.ico',
  dashboard: false,
  guide: false,
  proxyTarget: 'http://localhost:8080',
  distBasePath: './src/main/resources/lib',
  htmlPath: './src/main/resources/WEB-INF/view',
  homePath: undefined,
  menuTheme: 'light',
  resourcesLevel: ['site', 'user']
};

function getDwtConfig(configFile) {
  var customizedConfig = _fs["default"].existsSync(configFile) ? require(configFile) : {};
  return _objectSpread(_objectSpread({}, defaultConfig), customizedConfig);
}