"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = compile;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _crossSpawn = _interopRequireDefault(require("cross-spawn"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var cwd = process.cwd();
/**
 * 使用babel进行转义
 * 检测根目录下是否有`babel.config.js`，
 * 如果没有，使用boot里的配置
 * https://github.com/babel/babel/blob/master/packages/babel-cli/src/babel/options.js
 */

function compile() {
  var userBabelConfigFile = _path["default"].join(cwd, 'babel.config.js');

  var configFile = _fs["default"].existsSync(userBabelConfigFile) ? userBabelConfigFile : _path["default"].join(__dirname, '../../babel.config.js'); // eslint-disable-next-line camelcase

  var child_process = (0, _crossSpawn["default"])('babel', [_path["default"].join(cwd, 'react'), // 源文件路径
  '--config-file', configFile, // babel配置文件路径
  '--out-dir', _path["default"].join(cwd, 'lib'), // 输出路径
  '--copy-files', // 拷贝其他文件
  '--delete-dir-on-start' // 编译前先删除原来的
  ], {
    stdio: 'inherit'
  });
  child_process.on('close', function (code) {
    if (code === 1) {
      process.exit(1);
    }
  });
}