"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = start;

var _path = _interopRequireDefault(require("path"));

var _webpack = _interopRequireDefault(require("webpack"));

var _webpackDevServer = _interopRequireDefault(require("webpack-dev-server"));

var _gaze = _interopRequireDefault(require("gaze"));

var _context = _interopRequireDefault(require("./common/context"));

var _generateTransfer = _interopRequireDefault(require("./common/generateTransfer"));

var _generateEntry = _interopRequireDefault(require("./common/generateEntry"));

var _generateWebpackConfig = _interopRequireDefault(require("./common/generateWebpackConfig"));

var _generateEnvironmentVariable = _interopRequireDefault(require("./common/generateEnvironmentVariable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function restart(program, dev) {
  var open = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  // 初始化全局参数context
  var initContext = _context["default"].initContext;
  initContext(program, dev); // 前端环境变量方案处理

  (0, _generateEnvironmentVariable["default"])(true);
  var _context$dwtConfig = _context["default"].dwtConfig,
      entryName = _context$dwtConfig.entryName,
      devServerConfig = _context$dwtConfig.devServerConfig,
      output = _context$dwtConfig.output,
      port = _context$dwtConfig.port; // 生成入口文件

  (0, _generateTransfer["default"])(entryName);
  (0, _generateEntry["default"])(entryName);
  var webpackConfig = (0, _generateWebpackConfig["default"])('start', 'development', (0, _generateEnvironmentVariable["default"])(true));

  var serverOptions = _objectSpread(_objectSpread({
    quiet: true,
    hot: true,
    open: true
  }, devServerConfig), {}, {
    contentBase: [_path["default"].join(__dirname, '../../')],
    // 用于在本地启动时获取到生成的env-config.js
    historyApiFallback: true,
    host: 'localhost'
  });

  _webpackDevServer["default"].addDevServerEntrypoints(webpackConfig, serverOptions);

  var compiler = (0, _webpack["default"])(webpackConfig);
  var server = new _webpackDevServer["default"](compiler, serverOptions);
  server.listen(port, '0.0.0.0', function (err) {
    if (err) {
      throw err;
    }
  });
  return server;
}
/**
 * start project
 * @param program
 * @param dev
 */


function start(program, dev) {
  var server = restart(program, dev, true);
  var configFiles = [program.config, './react/.env', './react/.default.env'].map(function (file) {
    return _path["default"].join(process.cwd(), file);
  });
  (0, _gaze["default"])(configFiles, function (err, watcher) {
    // Files have all started watching
    // Get all watched files
    var watched = watcher.watched();
    watcher.on('all', function (event, filepath) {
      var filename = _path["default"].basename(filepath); // eslint-disable-next-line no-console


      console.log("Since ".concat(filename, " was ").concat(event, ", try to restart server..."));
      server.close(function () {
        server = restart(program, dev);
      });
    });
  });
}